// 2x2 Font with "anti-aliasing"
// Code: Cruzer/CML 2018
// Asm: KickAss 4.19
// test with: fOi=0to239:y%=i/40:pO1024+i,((y%aN1)+i*128+int(y%/2)*40+((i-y%*40)aN62))aN255:nE
// - or set showChars to true

.var showChars = false

.var srcPnt = 	$02
.var tmp = 	$08
.var buffer = 	$f6

.pc = $0801 "basic/code"

	.by $11, $08, $00, $00, $99, $22, $95, $93, $22, $3a
	.by $9e, $32, $30, $38, $32, $00, $00

pixels:
	.fill 16, ((((i + 0) & 1) << 0) | (((i + 0) & 2) << 1) | (((i + 0) & 4) << 2) | (((i + 0) & 8) << 3)) << 0

start:
	sei
	lda #$d8
cnt:	sta $d016
	ldx #$d3
	stx $d023
lineCnt:
	sax srcPnt + 1
	lda #$1e
	sta $d018
	sta $d022

	lsr $01

gfxLoopRestart:

	ldx #$00
gfxLoop:
	txa
	lsr
	tay

mask:	lda #%11110000
	anc #$ff
	and (srcPnt),y
	bcc noRoll
	lsr
	lsr
	lsr
	lsr
noRoll:	tay
	lda pixels,y
	sta.absx buffer + 2,x
ta:	
	adc.absx buffer + 0,x
	adc.absx buffer + 1,x

dest:	sta $3800,x

	inx
	bne gfxLoop

	inc dest + 2

	lda srcPnt + 0
	eor #$80
	sta srcPnt + 0
	bne gfxLoopRestart

	lda srcPnt + 1
	eor #$01
	sta srcPnt + 1
	lsr
	bcs gfxLoopRestart

	lda #%00001111
	sta mask + 1

	lsr cnt + 1
	bcc gfxLoopRestart

!:
	rol $01

.if (showChars) {

.pc = * "setup"

.var yPos = 19

yLoop:
	ldy #$00
xLoop:
	tya
	lsr
	sta tmp
	ror
	and #$80
	asl tmp
	ora tmp
add:	adc #$00
	sta $0400 + 40 * yPos,x
	adc #$01
	sta $0428 + 40 * yPos,x

	inx
	iny
	cpy #$28
	bne xLoop

	ldy #$00

	txa
	clc
	adc #$28
	tax

	lsr
	sta add + 1

	dec lineCnt + 1
	bne xLoop
}
	cli
	rts
